%{
    #include <stdio.h>
    extern void yyerror(char*);
%}

%token ICKE OCH ELLER IMPLIKATION EKVIVALENS SATS
%define parse.error verbose
%start formel

%%

enkelformel : SATS
            | '(' formel ')'
            ;

formel : enkelformel rest
       | ICKE enkelformel
       ;

rest : /* tomt */
     | OCH enkelformel
     | ELLER enkelformel
     | IMPLIKATION enkelformel
     | EKVIVALENS enkelformel
     ;

%%

int main() {
    printf("Mata in en logikformel. Avsluta med EOF.\n");
    yyparse();
    printf("Klart!\n");
    return 0;
}

void yyerror(char *s) {
    printf("Ogiltig formel! Felmeddelande: %s\n", s);
}

int yywrap(void) {
    return 1;
}
